//+------------------------------------------------------------------+
//|                                                  #MTF MACD X.mq4 |
//|                                      Copyright  2006, Eli Hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli Hayun"
#property link      "http://www.elihayun.com"

#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum 8
#property indicator_buffers 10
#property indicator_color1 Lime
#property indicator_color2 Lime
#property indicator_color3 Lime
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 Red
#property indicator_color7 Red
#property indicator_color8 Red
//---- input parameters
extern int       FastEMA=8;
extern int       SlowEMA=17;
extern int       MACDSignal=9;
//---- buffers
double UpBuffer_M5[];
double UpBuffer_M15[];
double UpBuffer_M30[];
double UpBuffer_H1[];
double UpBuffer_H4[];
double UpBuffer_D1[];
double DownBuffer_M5[];
double DownBuffer_M15[];
double DownBuffer_M30[];
double DownBuffer_H1[];
double DownBuffer_H4[];
double DownBuffer_D1[];

datetime dt5[200],dt15[200], dt30[200], dth1[200], dth4[200], dtd1[200];   

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,254);
   SetIndexBuffer(0,UpBuffer_M5);
   SetIndexEmptyValue(0,-40.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,254);
   SetIndexBuffer(1,UpBuffer_M15);
   SetIndexEmptyValue(1,-40.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,254);
   SetIndexBuffer(2,UpBuffer_M30);
   SetIndexEmptyValue(2,-40.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,254);
   SetIndexBuffer(3,UpBuffer_H1);
   SetIndexEmptyValue(3,-40.0);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,254);
   SetIndexBuffer(4,UpBuffer_H4);
   SetIndexEmptyValue(4,-40.0);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,254);
   SetIndexBuffer(5,UpBuffer_D1);
   SetIndexEmptyValue(5,-40.0);
    SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,253);
   SetIndexBuffer(6,DownBuffer_M5);
   SetIndexEmptyValue(6,-40.0);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,253);
   SetIndexBuffer(7,DownBuffer_M15);
   SetIndexEmptyValue(7,-40.0);
   SetIndexStyle(8,DRAW_ARROW);
   SetIndexArrow(8,253);
   SetIndexBuffer(8,DownBuffer_M30);
   SetIndexEmptyValue(8,-40.0);
   SetIndexStyle(9,DRAW_ARROW);
   SetIndexArrow(9,253);
   SetIndexBuffer(9,DownBuffer_H1);
   SetIndexEmptyValue(9,-40.0);
   SetIndexStyle(10,DRAW_ARROW);
   SetIndexArrow(10,253);
   SetIndexBuffer(10,DownBuffer_H4);
   SetIndexEmptyValue(10,-40.0);
   SetIndexStyle(11,DRAW_ARROW);
   SetIndexArrow(11,253);
   SetIndexBuffer(11,DownBuffer_D1);
   SetIndexEmptyValue(11,-40.0);
   
   IndicatorShortName("MTMACDexp("+FastEMA+","+SlowEMA+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int limit, shift;
   if(counted_bars<0) return(-1);
   if (counted_bars==0) limit=Bars-1;  // limit = Bars-MinBars-1;
//---- last counted bar will be recounted
   if(counted_bars>0) limit=Bars-counted_bars;
   limit--;

   int i5 = 0,i15 = 0, i30 = 0, ih1 = 0, ih4 = 0, id1 = 0;

   static bool fft = true;
   
   //if (NewBar()) // Update array every 5 minutes
   {
      ArrayCopySeries(dt5,MODE_TIME,Symbol(),PERIOD_M5);
      ArrayCopySeries(dt15,MODE_TIME,Symbol(),PERIOD_M15); 
      ArrayCopySeries(dt30,MODE_TIME,Symbol(),PERIOD_M30); 
      ArrayCopySeries(dth1,MODE_TIME,Symbol(),PERIOD_H1); 
      ArrayCopySeries(dth4,MODE_TIME,Symbol(),PERIOD_H4); 
      ArrayCopySeries(dtd1,MODE_TIME,Symbol(),PERIOD_D1);
   }   
   
   if ((fft) && (Symbol() == "EURUSD"))
   {
      fft = false;
      datetime d = iTime(NULL, PERIOD_D1, 0);
      for (int j=0; j<80; j++)
      {
         Print(j,")",dt5[j]-d," ",dt15[j]-d," ",dt30[j]-d," ", dth1[j]-d," ", dth4[j]-d," ", dtd1[j]-d;
      }
   }
   for(int i=0; i<limit; i++)
   {   
      datetime ddt = iTime(NULL, 0, i);
       if (ddt<dt5[i5]) i5++;
      if (ddt<dt15[i15]) i15++;
      if (ddt<dt30[i30]) i30++;
      if (ddt<dth1[ih1]) ih1++;
      if (ddt<dth4[ih4])  ih4++;
      if (ddt<dtd1[id1])  id1++;
      
       double macd_m5 = iMACD(NULL,PERIOD_M5, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_MAIN,i5);
       double macd_s5 = iMACD(NULL,PERIOD_M5, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_SIGNAL,i5);
      double macd_m15 = iMACD(NULL,PERIOD_M15, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_MAIN,i15);
      double macd_s15 = iMACD(NULL,PERIOD_M15, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_SIGNAL,i15);
      double macd_m30 = iMACD(NULL,PERIOD_M30, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_MAIN,i30);
      double macd_s30 = iMACD(NULL,PERIOD_M30, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_SIGNAL,i30);
      double macd_h1 = iMACD(NULL,PERIOD_H1, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_MAIN,ih1);
      double macd_sh1 = iMACD(NULL,PERIOD_H1, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_SIGNAL,ih1);
      double macd_h4 = iMACD(NULL,PERIOD_H4, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_MAIN,ih4);
       double macd_sh4 = iMACD(NULL,PERIOD_H4, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_SIGNAL,ih4);
       double macd_d1 = iMACD(NULL,PERIOD_D1, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_MAIN,id1);
      double macd_sd1 = iMACD(NULL,PERIOD_D1, FastEMA,SlowEMA,MACDSignal,1,PRICE_CLOSE, MODE_SIGNAL,id1);
      
      UpBuffer_M5[i] = -40;    DownBuffer_M5[i] = -40;
      UpBuffer_M15[i] = -40;    DownBuffer_M15[i] = -40; 
      UpBuffer_M30[i] = -40;    DownBuffer_M30[i] = -40; 
      UpBuffer_H1[i]  = -40;    DownBuffer_H1[i]  = -40; 
      UpBuffer_H4[i]  = -40;    DownBuffer_H4[i]  = -40;
      UpBuffer_D1[i]  = -40;    DownBuffer_D1[i]  = -40; 
      
      if (macd_m5 > macd_s5) UpBuffer_M5[i] = 1;   if (macd_m5 < macd_s5) DownBuffer_M5[i] = 1;
      if (macd_m15 > macd_s15) UpBuffer_M15[i] = 2; if (macd_m15 < macd_s15) DownBuffer_M15[i] = 2;
      if (macd_m30 > macd_s30) UpBuffer_M30[i] = 3; if (macd_m30 < macd_s30) DownBuffer_M30[i] = 3;
      if (macd_h1 > macd_sh1) UpBuffer_H1[i]   = 4; if (macd_h1  < macd_sh1) DownBuffer_H1[i]  = 4;
      if (macd_h4 > macd_sh4) UpBuffer_H4[i]   = 5; if (macd_h4  < macd_sh4) DownBuffer_H4[i]  = 5;
      if (macd_d1 > macd_sd1) UpBuffer_D1[i]   = 6; if (macd_d1  < macd_sd1) DownBuffer_D1[i]  = 6;
   }

   return(0);
  }
//+------------------------------------------------------------------+

/*
bool NewBar()
{
   static datetime dt = 0;
   if (dt != iTime(NULL, PERIOD_M5, 0))
   {
      dt = iTime(NULL, PERIOD_M5, 0);
   }
   return(false);
}
*/